def ma_fonction(x, y):
    return x + y 

x = ma_fonction

L = [x, x, x]
print(L[0](3, 4)) # retourne 7


def apply(fct, arg1, arg2):
    return fct(arg1, arg2)

print(apply(x, 3, 4)) # retourn 7


# Argument variadique

def somme_arg(*args):
    ac = 0
    for a in args:
        ac += a
    return ac

print(somme_arg(0, 1, 2, 3, 123)) # retourne 129

def decorateur(fct):
    def new_fct(*args):
        print("je suis décoré")
        return fct(*args)
    return new_fct

xdec = decorateur(x)
xdec(3, 4)
# je suis décoré
# 7

def mesure_temps(fct):
    def new_fct(*args, decore=True):
        if not decore:
            return fct(*args)
        t1 = time.time()
        res = fct(*args)
        t2 = time.time()
        print(f"time:{t2-t1}")
        return res
    return new_fct


@mesure_temps
def index(L, a):
    if a in L:
        return L.index(a)
    return None
L = list(range(10**8))

index(L, -1)
# retourne: time:0.769646167755127

# Itérateur/Itérable

s = "coucou" # Iterable
it = iter(s) # Iterateur

def boucle_for(L, fct):
    it = iter(L)
    while True:
        try:
            fct(next(it))
        except StopIteration:
            break

print(boucle_for(it, print)) # retourne "coucou" verticalement
print(boucle_for(it, print)) # retourne rien


print(boucle_for(s, print)) # retourne "coucou" verticalement
print(boucle_for(s, print)) # retourne "coucou" verticalement

# Map / Reduce

def mon_map(fct, L):
    K = []
    for a in L:
        K.append(fct(a))
    return K

